#version 330

in vec2 textureCoords;

out vec4 out_Color;
uniform sampler2D cartesianTexture;
uniform vec2 center;

const float PI = 3.14159265359;
const float SQRT2 = 1.41421356237;

void main(void) {
	
	float phi = textureCoords.x * 2 * PI;
	float r = textureCoords.y * SQRT2;
	
	float x = cos(phi) * r;
	float y = sin(phi) * r;
	
	x += center.x;
	y += center.y;
	
	if(x < 0.0 || x > 1.0 || y < 0.0 || y > 1.0){
		discard;
	}
	out_Color = texture(cartesianTexture, vec2(x, y));
}