#version 400 core

in vec2 texCoords;

uniform sampler2D originalTexture;
uniform float radius;
uniform float alpha;
uniform float targetHeight;

out vec4 out_colour;

void main(void){
	
	float pixelHeight = 1.0 / targetHeight;
	vec2 samplePos = vec2(texCoords.x, 0);
	vec4 color = vec4(0, 0, 0, 0);
	
	for(int i = 0; i < radius; i++){
		color += texture(originalTexture, samplePos) / radius;
		samplePos += vec2(0, pixelHeight);
	}
	
	out_colour = (1.0-alpha) * texture(originalTexture, texCoords) + alpha * color;
}