#version 420
in vec2 TexCoord0;
in vec2 TexCoord1;

flat in float TTL0;
flat in float blendFac;

uniform sampler2D particleTexture;

layout (location = 0) out vec4 out_Color;
layout (location = 1) out vec4 out_BrightColour;
layout (location = 2) out vec4 out_lightColor;

vec3 pow3(vec3 v, float p) { 
	return pow(abs(v), vec3(p)); 
}
vec3 glowSphere(vec3 color, vec2 p, float radius, float glow) {
	// Inspired by https://www.shadertoy.com/view/4lfXRf
	float term = 1./length(p)/5.;
	return pow3(color * term * 0.5, glow) * radius;
}
void main() {





	vec4 color1 = texture(particleTexture, TexCoord0);
	vec4 color2 = texture(particleTexture, TexCoord1);
	out_Color = mix(color1, color2, blendFac);
	
	out_BrightColour = vec4(0, 0, 0, 1);
	if(out_Color.r * 0.2126 + out_Color.g * 0.7152 + out_Color.b * 0.0722 > 0.9){
		out_BrightColour = out_Color;
	}
	out_lightColor = vec4(0, 0, 0, 1);
}
