#version 330
layout (points) in; // points in
layout (triangle_strip, max_vertices = 4) out; // quads out
uniform mat4 ProjectionMatrix;
uniform int NumRows;

in vData{
float TTL1;
float texOff1;
float texOff2;
float texOff3;
float texOff4;
float blendFactor;
} vertex[];

out vec2 TexCoord0;
out vec2 TexCoord1;


flat out float TTL0; // flat: no interpolation between vertices
flat out float blendFac;


void main () {

	const vec2 size = vec2(1, 1);
	vec4 P = gl_in[0].gl_Position; //asdf  position in view-space
		// b: left-top
	vec2 vb = P.xy + vec2(-0.5, 0.5) * size;
	gl_Position = ProjectionMatrix * vec4(vb,P.zw);
	vec2 texcoord = vec2(0.0, 1.0);
	texcoord/=NumRows;
	TexCoord0 = texcoord + vec2(vertex[0].texOff1,vertex[0].texOff2);
	TexCoord1 = texcoord + vec2(vertex[0].texOff3,vertex[0].texOff4);


	TTL0 = vertex[0].TTL1;
	blendFac = vertex[0].blendFactor;
	EmitVertex();  

	
	vec2 va = P.xy + vec2(-0.5, -0.5) * size; // bottom-left corner
	gl_Position = ProjectionMatrix * vec4(va,P.zw);

	texcoord = vec2(0.0, 0.0);
	texcoord/=NumRows;
	TexCoord0 = texcoord + vec2(vertex[0].texOff1,vertex[0].texOff2);
	TexCoord1 = texcoord + vec2(vertex[0].texOff3,vertex[0].texOff4);

	TTL0 = vertex[0].TTL1;
	blendFac = vertex[0].blendFactor;
	EmitVertex();

		// c: right-top
	vec2 vc = P.xy + vec2(0.5, 0.5) * size;
	gl_Position = ProjectionMatrix * vec4(vc,P.zw);
	texcoord = vec2(1.0, 1.0);
	texcoord/=NumRows;
	TexCoord0 = texcoord + vec2(vertex[0].texOff1,vertex[0].texOff2);
	TexCoord1 = texcoord + vec2(vertex[0].texOff3,vertex[0].texOff4);


	TTL0 = vertex[0].TTL1;
	blendFac = vertex[0].blendFactor;
	EmitVertex();  




	// d: right-bottom
	vec2 vd = P.xy + vec2(0.5, -0.5) * size;
	gl_Position = ProjectionMatrix * vec4(vd,P.zw);
	
	texcoord = vec2(1.0, 0.0);
	texcoord/=NumRows;
	TexCoord0 = texcoord + vec2(vertex[0].texOff1,vertex[0].texOff2);
	TexCoord1 = texcoord + vec2(vertex[0].texOff3,vertex[0].texOff4);


	TTL0 = vertex[0].TTL1;
	blendFac = vertex[0].blendFactor;
	EmitVertex();  



	EndPrimitive();
}
