#version 420
layout(location = 0) in vec4 Position;
uniform mat4 ModelViewMatrix;
uniform int NumRows;
out vData{
float TTL1;
float texOff1;
float texOff2;
float texOff3;
float texOff4;
float blendFactor;
} vertex;

void main(){
	gl_Position = ModelViewMatrix * vec4(Position.xyz, 1.0f);
	vertex.TTL1 = Position.w;

	float lifeFactor = Position.w / 10;
	int stageCount = NumRows * NumRows;
	float atlasProgression = lifeFactor * stageCount;
	int index1 = int(atlasProgression);
	int index2 = index1;
	if(index1 < stageCount-1){
		index2 = index1 + 1;
	}
	
	vertex.blendFactor = atlasProgression - index1;

	int column = index1 % NumRows;
	int row = index1 / NumRows;

	vertex.texOff1 = float(column)/float(NumRows);
	vertex.texOff2 = float(row) / float(NumRows);

	column = index2 % NumRows;
	row = index2 / NumRows;

	vertex.texOff3 = float(column)/float(NumRows);
	vertex.texOff4 = float(row) / float(NumRows);



}
