#version 400 core

in vec2 centerTexCoords;

uniform sampler2D originalTexture;
uniform int kernelWidth;
uniform int targetWidth;

out vec4 out_colour;

void main(void){
	
	float pixelSize = 1.0 / targetWidth;
	int offset = (kernelWidth-1)/2;
	
	out_colour = vec4(0.0);
	vec2 samplePos;
	for(int i = 0; i < kernelWidth; i++){
		samplePos = centerTexCoords + vec2(pixelSize * (i-offset), 0.0);
		out_colour += texture(originalTexture, samplePos) / kernelWidth;
	}
}