#version 400 core

in vec2 pass_texCoords1;
in vec2 pass_texCoords2;
in float pass_blendFactor;

uniform sampler2D particleTexture;

layout (location = 0) out vec4 out_Color;
layout (location = 1) out vec4 out_BrightColour;
layout (location = 2) out vec4 out_lightColor;

void main(void){

	vec4 color1 = texture(particleTexture, pass_texCoords1);
	vec4 color2 = texture(particleTexture, pass_texCoords2);
	out_Color = mix(color1, color2, pass_blendFactor);
	
	out_BrightColour = vec4(0, 0, 0, 1);
	if(out_Color.r * 0.2126 + out_Color.g * 0.7152 + out_Color.b * 0.0722 > 0.9){
		out_BrightColour = out_Color;
	}
	out_lightColor = vec4(0, 0, 0, 1);
}