#version 400 core

in vec2 position;
in mat4 modelViewMatrix;
in vec4 texOffsets;
in float blendFactor;

uniform mat4 projectionMatrix;
uniform int numberOfRows;

out vec2 pass_texCoords1;
out vec2 pass_texCoords2;
out float pass_blendFactor;

void main(void){
	vec2 texCoords = (position + vec2(1, 1))/2;
	texCoords.y = 1.0 - texCoords.y;
	texCoords /= numberOfRows;
	pass_texCoords1 = texCoords + texOffsets.xy;
	pass_texCoords2 = texCoords + texOffsets.zw;
	pass_blendFactor = blendFactor;
	
	gl_Position = projectionMatrix * modelViewMatrix * vec4(position, 0.0, 1.0);
}