#version 330

in vec2 textureCoords;

out vec4 out_Color;
uniform sampler2D polarTexture;
uniform vec2 center;

const float PI = 3.14159265359;
const float SQRT2 = 1.41421356237;

void main(void) {
	
	float x = textureCoords.x;
	float y = textureCoords.y;
	
	x-=center.x;
	y-=center.y;
	
	float r = sqrt(x*x + y*y) / SQRT2;
	
	float phi = atan(y/x);
	if(sin(x) < 0)
		phi += PI;
	phi /= (2*PI);
	
	out_Color = texture(polarTexture, vec2(phi,r));
}