#version 330

in vec3 position;
out vec2 textureCoords;

uniform mat4 transformationMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;

void main(void){
	
	vec4 worldPosition = transformationMatrix * vec4(position, 1.0);
	gl_Position = projectionMatrix * viewMatrix * worldPosition;
	
	textureCoords = vec2(position.x/2 + 0.5, position.y/2 + 0.5);
}