#version 140

const int NUM_LIGHTS = 2;

in vec3 position;
in vec3 normals;

out vec2 textureCoords;
out vec3 out_normals;
out vec3 toLightVector[NUM_LIGHTS];

uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform mat4 modelMatrix;
uniform vec3 lightPosition[NUM_LIGHTS];
uniform vec4 clipPlane;
uniform float textureTiling;

void main(void) {
	
	vec4 worldPosition = modelMatrix * vec4(position, 1.0);
	gl_ClipDistance[0] = dot(worldPosition, clipPlane);
	gl_Position = projectionMatrix * viewMatrix * worldPosition;
	
 	textureCoords = vec2(position.x/textureTiling, position.z/textureTiling);
	out_normals = (modelMatrix * vec4(normals, 0.0)).xyz;
	out_normals = normalize(out_normals);
	
 	for(int i = 0; i < NUM_LIGHTS; i++){
		toLightVector[i] = lightPosition[i] - worldPosition.xyz;
	}
}