#version 400 core

in vec2 centerTexCoords;

uniform sampler2D originalTexture;
uniform int kernelHeight;
uniform int targetHeight;

out vec4 out_colour;

void main(void){
	
	float pixelSize = 1.0 / targetHeight;
	int offset = (kernelHeight-1)/2;
	
	out_colour = vec4(0.0);
	vec2 samplePos;
	for(int i = 0; i < kernelHeight; i++){
		samplePos = centerTexCoords + vec2(0.0, pixelSize * (i-offset));
		out_colour += texture(originalTexture, samplePos) / kernelHeight;
	}
}